import time
import logging
import twisted.internet.reactor
import threading

class inthread:

	def __init__(self):
		self.logger = logging.getLogger("inthread")
#		self.cond = threading.Lock()
		self.cond = threading.Condition()
		self.queue = [ ]

	def dispatch(self,val):
		self.cond.acquire(True)
		self.logger.debug("dispatch %s",str(val))
		self.queue.append(val)
		self.cond.notify()
		self.cond.release()

	def process_pending_queue(self,ctx):
		job = None
		while True:
			self.cond.acquire(True)
			if len(self.queue) > 0:
				job = self.queue.pop(0)
			else:
				job = None
				self.logger.debug("Waiting on condition")
				self.cond.wait()
			self.cond.release()
		
			if job == "exit":
				return
			elif job == None:
				pass
			else:
				self.logger.debug("thread start %i",job)
				time.sleep(2 + ( job % 2 ))
				self.logger.debug("thread stop  %i",job)

class mainjob:

	def __init__(self):
		self.logger = logging.getLogger("mainjob")

	def run(self):
		self.threadclass = inthread()
		twisted.internet.reactor.callLater(1,self.runThreadTest)
		twisted.internet.reactor.callLater(90,self.shutdownApp)
		twisted.internet.reactor.run()

	def runThreadTest(self):
		self.logger.debug("Running thread test")
		self.logger.debug("scheduling thread operation")
		twisted.internet.reactor.callInThread(self.threadclass.process_pending_queue,0)
		time.sleep(4)
		for i in range(0,20):
			self.threadclass.dispatch(i)
			if i == 3:
				time.sleep(10)
			else:
				time.sleep(1)
		time.sleep(10)
		self.threadclass.dispatch("exit")
		self.logger.debug("done sleeping")

	def shutdownApp(self):
		#DBGOUT#print "Stopping"
		twisted.internet.reactor.stop()
		
logging.basicConfig(level=logging.DEBUG,
	format="%(levelname)-5s %(name)-10s %(threadName)-10s %(message)s")
#	format="%(asctime)s %(levelname)-5s %(name)-10s %(threadName)-10s %(message)s")

m = mainjob()
m.run()
	

